﻿/**
 * Screen test by Blueline Design 
 * @author Blueline Design - support@bluelinedesign.se
 * @description Lightweight web based screen test.
 *                          
 */

$(function() {
	
	if ( visitor ) { 
		
		visitor.screenWidth = Math.round(screen.width * window.devicePixelRatio);
		visitor.screenHeight = Math.round(screen.height * window.devicePixelRatio);
		visitor.userAgent = navigator.userAgent;
		visitor.colorDepth = (screen.colorDepth > 0) ? screen.colorDepth + " bit" : "N/A";
		
		//$("#info-screen").html(visitor.screenWidth + "x" + visitor.screenHeight + "@" + visitor.colorDepth  + ". IP: " + visitor.ip);
	
	}
	

	//var colors = ["white", "#CCCCCC", "#333333", "#999999", "black", "green", "red", "blue"];
	var colors = ["#000000", "#808080", "#FFFFFF", "#800000", "#FF0000", "#008000", "#00FF00", "#000080", "#0000FF"];
	var color = 0;
	
	var gradients = ["vtblacktogrey","vtgreytowhite", "vtblacktored", "vtredtolightred", "vtblacktogreen", "vtgreentolightgreen", "vtblacktoblue", "vtbluetolightblue"];
	var gradient = 0;

	var fullscreen = false;
	
	var $overlay = $("#overlay");
	var $drawer = $("#overlay-menu");
	
	
	/*
	$.get( "help.php", function( data ) {
	  //$( ".result" ).html( data );
	  console.log( data );
	});*/


	//  b$( "#welcome-screen" ).load( "tmpl-welcome.php" );


	
	$("#menu").click(function() { 
		
		$("html").addClass("noscroll");
		$overlay.show();
		$drawer.animate({ width : 'show' }, 350);
	});
	
	$overlay.click(function() { 

		$drawer.animate({ width : 'hide' }, 350, function() { 
			
			$("html").removeClass("noscroll");
			$overlay.hide();
			
			$overlay.trigger("hidden");
			
		
		});	
	
	
	});
	

	
	
	$("#fullscreen").click(function() { 
		
		if ( ! fullscreen ) {
			launchFullScreen(document.documentElement);
			fullscreen = true;
		} else {
			exitTheFullscreen();
			
		}
	});

	
	// *** Test 1, uniformity
	$("#uniformity").click(function() { 
	
		launchFullScreen(document.documentElement);
		//hideWelcome();
		
	
		
		
		/*
		$("#info-screen").html("Look for dots that light through the background if so you might have a dead pixel.");
		$("#info-screen").slideDown("slow", function() { 
			$("#info-screen").delay(5000).slideUp("slow");
		
		});*/

		//showInfo( "All solid colors should appear uniform with few imperfections. Clouding/Flashlighting: Do you see brighter patches on parts of the screen? Dead pixels: Do you see any stuck bright or dark dots?", 10 );


		
		$("#document").off(".gradient");
		
		$("#document").on("click.uniformity", function( e ) { 
		//$("#document").on("click.uniformity touchstart.uniformity", function( e ) { 
			
			//e.preventDefault();
			
			if (color >= colors.length ) { 
				color = 0;
			} 

			// *** Color of moving circle
			if (colors[color] == "#FFFFFF") { 
				$("#pan").css("background-color", "#000");	
			} else { 
				$("#pan").css("background-color", "#fff");
			}
			
			
			$("body").css("background", colors[color]);
			
			color ++;
		});	
	
	});
	
	// *** Test 2, gradients
	$("#gradient").click(function() { 
	
		launchFullScreen(document.documentElement);
		//hideWelcome();
		
		//showInfo( "Do you see bands of colors or a very smooth gradient? Smooth gradient can be important for details in shadows, sky, skin tones etc.", 10 );
		
		
		$("#document").off(".uniformity");
		$("body").removeAttr("style");
		
		$("#document").on("click.gradient", function( e ) { 
		//$(document).on("click.gradient touchstart.gradient", function( e ) { 
			
			//e.preventDefault();
			
			if (gradient >= gradients.length ) {
				
				allGradients();
				//allGradientsReversed();
				
				gradient = -1;
			} else { 
				$("#document").empty();
			}
			
			$("body").attr("class", gradients[gradient] );
			
			gradient ++;
		});	
	
	});

	// *** Test 3, soccer like background movements
	$("#soccer").click( function() { 
		launchFullScreen(document.documentElement);
		//hideWelcome();
		soccerMatch(); 
	});
	
	$("#soccer-field-container").click( stopSoccerMatch );
	
	
	// *** Test 4, screen movements
	var running = false;
	
	$("#movement").click(function() {
		
		launchFullScreen(document.documentElement);
		//hideWelcome();
	
		//showInfo( "Does eventual local dimming work well? Is only the box/circle visible without any other parts of the screen illuminated?", 10 );
		
		
		// *** Color of moving circle
		var current_bg_color = $("body").css("background-color");
		if (  current_bg_color === "rbg(255, 255, 255)" ||  current_bg_color === "rgba(0, 0, 0, 0)" || current_bg_color === "transparent" ) { 
			$("#pan").css("background-color", "#000");
		} else { 
			 $("#pan").css("background-color", "#fff");
		}
		
		if ( ! running ) { 
			runPan();
			running = true;
			$("#movement").html('<i class="material-icons">&#xE047;</i> ' + lang.removeMovement);
		} else { 
			stopPan();
			running = false;
			$("#movement").html('<i class="material-icons">&#xE047;</i> ' + lang.addMovement);
		}

	});
	
	
	$("#cross").click(function() { 
		
		var toggle = $(this).find(".toggle");
		
		if ( $("#cross-screen").css("display") === "none" ) { 
			$("#cross-screen").show();
			toggle.html( lang.hideCross );
		} else { 
			$("#cross-screen").hide();
			toggle.html( lang.showCross );
		}
		
		
	
	});



	// *** Info screen
	$("#info").click(function() {
		
		showInfo ( visitor.screenWidth + "x" + visitor.screenHeight + "@" + visitor.colorDepth  + ". IP: " + visitor.ip );
		/*
		$overlay.on("hidden", function() { 
			$("#info-screen").slideToggle("slow", function() { 
				$overlay.off("hidden");
			
			});
		});*/

	});



	
	
	
	// *** Help screen
	$("#help").click(function() { 
		
		/* $overlay.on("hidden", function() { 
			
			$("#help-screen").animate({ width : 'show' }, 350, function() { 
				$overlay.off("hidden");
			});
			

		});*/
	});
	
	
	$("#quit").click(function() { 
		
		//exitTheFullscreen();
	
		if ( running ) { 
			
			stopPan();
			running = false;
			$(this).html('<i class="material-icons">&#xE047;</i> Add movment');
		}
	
		stopSoccerMatch();
		exitTheFullscreen();
		showWelcome();
		
		
		
	});
		
	
	// ***************************************************************************
	// *** Supporting functions
	// ***************************************************************************
	
	
	/* Gradients */
	
	function allGradients() { 
	
		for ( var i = 0; i < gradients.length; i++ ) {
			
			var gradient = gradients[i].replace("vt", "hl");
			$("#document").append('<div class="gradient '+gradient+'"></div>');	
		}
	}
	
	function allGradientsReversed() { 
	
		for ( var i = gradients.length-1; i >= 0; i-- ) {
			var gradient = gradients[i].replace("vt", "hl");
			$("#document").append('<div class="gradient '+gradient+'"></div>');	
		}
	}	
	
	
	
	/* Movements */

	var originalWidth = 0;
	
	function runPan() {
		
		var w = $("body").width();
		var h = $("body").height();
		
		var ow = 0;
		
		if ( h > w ) { 
			$("#pan").css("height", "10%");
			ow =  $("#pan").height();
			$("#pan").css("width", ow);
		
		} else { 
			
			$("#pan").css("width", "10%");
			ow =  $("#pan").width();
			$("#pan").css("height", ow);
		
		}	
		
		originalWidth = ow;
		
		$("#pan").css("border-radius", "0px");
		
		
		/*$("#pan").show("slow")
		.animate({ left: "+=" +(w - ow ) }, 2000 )
		.animate({ top: "+=" +(h - ow ) }, 2000 )
		.animate({ left: "-=" +(w - ow ) }, 2000 )
		.animate({ top: "-=" +(h - ow ) }, 2000 )

		.animate({ top: "+=" +(h - ow ), left:(w/2) - ow}, 2000 )
		.animate({ top: "-=" +(h - ow ), left:(w - ow)}, 2000,  startSecond  );	 */	
		
	
		$("#pan").show("slow")
		.animate({ left: "+=" +(w - ow ) }, 2000 )
		.animate({ top: "+=" +(h - ow ) }, 2000 )
		.animate({ left: "-=" +(w - ow ) }, 2000 )
		.animate({ top: "-=" +(h - ow ) }, 2000 )
		.animate({ left:ow, top:ow, borderRadius:"50%" }, 1000, startSecond );
	}

	
	function startSecond() { 
		//$("#pan").addClass("round");
		runPanRandom();
	}
	

	
	function runPanRandom() {

		var pos = makeNewPosition();
		var size = makeNewSize();
		//$("#pan").animate({ top: pos.top, left:pos.left, width:size.width, height:size.height }, 2000, runPanRandom );
		$("#pan").animate({ top: pos.top, left:pos.left }, 2000, runPanRandom );
	
	}	
	
	function stopPan() { 
		
		var pan = $("#pan");
		pan.css({top:0,left:0,display:"none"});
		pan.clearQueue();
		pan.stop();	
	}
	
	function makeNewSize() { 
		
		var w = originalWidth;
		var nw =  Math.floor(Math.random() * w);
		
		return {width:nw, height:nw};
	
	}
	
	function makeNewPosition($container) {
	
		// Get viewport dimensions (remove the dimension of the div)
		//$container = ($container || $(window))
		$container = ($container || $("body"));
		var h = $container.height() - 200;
		var w = $container.width() - 200;
	
		var nh = Math.floor(Math.random() * h);
		var nw = Math.floor(Math.random() * w);
	
		return {top:nh, left:nw};
	}
	
	/* Sports */
	
	function soccerMatch() { 
		
		$("#soccer-field-container").show();
		$("#soccer-field")
		.animate({ left: "-=" +($("body").width()) }, {easing: "linear", duration:5000})
		.animate({ left: "+=" +($("body").width()) }, {duration: 5000, easing: "linear", complete:soccerMatch});
	}
	
	function stopSoccerMatch() { 
		
		$("#soccer-field-container").hide();
		$("#soccer-field")
		.css({left:0})
		.clearQueue()
		.stop();	
	}
	
	
	
	/* Info */
	
	function showInfo( info, sec ) { 

		var delay = (sec) ? sec * 1000 : 5000;
		
		var $info_screen = $("#info-screen");
		$info_screen.html( info );
		
		$overlay.on("hidden", function() { 
			$info_screen.slideToggle("slow", function() { 
				$overlay.off("hidden");
			
				$info_screen.delay( delay ).slideUp("slow");
			
			
			});
		});	
	}
	
	
	/* Welcome */
	
	function showWelcome() {
		
		$("body").removeAttr("style");
		$("body").removeAttr("class");
		//$("#welcome-screen").slideDown();
	

		$overlay.on("hidden", function() { 
			
			$("#welcome-screen").slideDown("slow", function() { 
				$overlay.off("hidden");
		
			});
		});
	
	
	
	
	}
	
	function hideWelcome() { 
		$("#welcome-screen").slideUp();
	}
	
	/* Fullscreen */
	
	function launchFullScreen( element ) {
		
		if (element.requestFullScreen) {
			element.requestFullScreen();
		} else if (element.msRequestFullscreen) {
			element.msRequestFullscreen();
		} else if (element.mozRequestFullScreen) {
			element.mozRequestFullScreen();
		} else if (element.webkitRequestFullScreen) {
			element.webkitRequestFullScreen();
		}
		
		fullscreen = true;
		
		hideWelcome();
		$("#fullscreen").html('<i class="material-icons">&#xE5D1;</i> ' + lang.exitFullscreen);
	
	}
	
	function exitTheFullscreen() { 
	
		if (document.exitFullscreen) {
			document.exitFullscreen();
		} else if (document.webkitExitFullscreen) {
			document.webkitExitFullscreen();
		} else if (document.mozCancelFullScreen) {
			document.mozCancelFullScreen();
		} else if (document.msExitFullscreen) {
			document.msExitFullscreen();
		}
		
		fullscreen = false;
		
		//showWelcome();
		$("#fullscreen").html('<i class="material-icons">&#xE5D0;</i> ' + lang.fullscreen);
	
	}
});